# Copyright (C) 2021 Associated Universities, Inc. Washington DC, USA.
#
# This file is part of NRAO Workspaces.
#
# Workspaces is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Workspaces is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Workspaces.  If not, see <https://www.gnu.org/licenses/>.
"""add has_image_products column to capability requests

Revision ID: ff458e15d7b1
Revises: 81679be895a6
Create Date: 2021-08-12 16:09:08.254902

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "ff458e15d7b1"
down_revision = "81679be895a6"
branch_labels = None
depends_on = None

workflows_with_image_products = ["std_calibration", "std_cms_imaging", "std_restore_imaging"]


def upgrade():
    op.execute("ALTER TABLE capabilities ADD COLUMN has_image_products bool NOT NULL DEFAULT false")
    for wf_name in workflows_with_image_products:
        op.execute(f"UPDATE capabilities SET has_image_products = TRUE WHERE capability_name = '{wf_name}'")


def downgrade():
    op.execute("ALTER TABLE capabilities DROP COLUMN IF EXISTS has_image_products")
